
#include <windows.h>  
#include "FndFCNot.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

static HANDLE hWait = NULL;
static int    nTab  = 50;

DWORD DirChanges( LPDWORD lpdwParam )
{
   HWND   hWnd = (HWND)lpdwParam;

   // Process forever, or until terminated.
   //......................................
   while( TRUE )
   {
      // Wait for a change notification to happen.
      //..........................................
      if ( WaitForSingleObject( hWait, INFINITE ) == WAIT_OBJECT_0 )
      { 
         // Update the window with new information.
         //........................................
         InvalidateRect( hWnd, NULL, TRUE );
         UpdateWindow( hWnd );
      }

      // Find next change notification.
      //...............................
      FindNextChangeNotification( hWait );
   }

   return( 0 );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
static DWORD  dwID;
static char   szOut[128];
static HANDLE hThread = NULL;

   switch( uMsg )
   {
      case WM_CREATE :
              {
                 // Start change notification.
                 //...........................
                 hWait = FindFirstChangeNotification( "D:\\TEMP", FALSE, 
                                           FILE_NOTIFY_CHANGE_FILE_NAME |
                                           FILE_NOTIFY_CHANGE_SIZE |
                                           FILE_NOTIFY_CHANGE_LAST_WRITE );

                 // Create a thread to monitor changes.
                 //....................................
                 hThread = CreateThread( NULL, 0, 
                                      (LPTHREAD_START_ROUTINE)DirChanges,
                                      hWnd, 0, &dwID );
              }
              break;

      case WM_PAINT :
              { 
                 HANDLE          hFind;
                 SYSTEMTIME      sysTime;
                 FILETIME        fLocTime;
                 WIN32_FIND_DATA fd;
                 PAINTSTRUCT     ps;
                 int             yPos = 0;
                 BOOL            bRet = TRUE;

                 BeginPaint( hWnd, &ps );

                 // Start listing of files.
                 //........................
                 hFind = FindFirstFile( "D:\\TEMP\\*.*", &fd );

                 // While there are more files, continue processing.
                 //.................................................
                 while ( hFind != INVALID_HANDLE_VALUE && bRet )
                 {
                    // Display the file and its information if this is
                    // not a directory that we found.
                    //................................................
                    if ( (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)
                    {
                       // Convert the file time to a local time, then to
                       // a SYSTEMTIME structure so we can display it.
                       //...............................................
                       FileTimeToLocalFileTime( &fd.ftLastWriteTime, 
                                                &fLocTime );
                       FileTimeToSystemTime( &fLocTime, &sysTime );

                       // Output the files information.
                       //...............................
                       yPos += 15;
                       wsprintf( szOut, 
                                 "%s \t %.2d/%.2d/%.4d \t %.2d:%.2d:%.2d \t %d", 
                                 fd.cFileName, 
                                 sysTime.wMonth,
                                 sysTime.wDay,
                                 sysTime.wYear,
                                 sysTime.wHour,
                                 sysTime.wMinute,
                                 sysTime.wSecond,
                                 fd.nFileSizeLow );

                       TabbedTextOut( ps.hdc, 10, yPos, szOut, 
                                      strlen( szOut ), 1, &nTab, 10 );
                    }

                    // Find the next file.
                    //....................
                    bRet = FindNextFile( hFind, &fd );
                 }

                 // Close the find.
                 //................
                 FindClose( hFind );

                 EndPaint( hWnd, &ps );
              }
              break;

      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              // Terminate thread that is waiting for changes.
              //..............................................
              if ( hThread )
                 TerminateThread( hThread, 0 );

              // Close the change notification.
              //...............................
              if ( hWait )
                 FindCloseChangeNotification( hWait );

              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
